/* o_ovlt.c - Trivial overlaps - Don Yang / Dave Newquist / John Rapp

   07/28/01
                                                                           */

#include<assert.h>
#include<stdio.h>
#include"token.h"
#include"tree.h"


/******************************************************* o_trivial_overlap */
int o_trivial_overlap(Node **node)
{
   int modified;

   modified = 0;
   while( *node )
   {
      if( (*node)->token->type == TagColor )
      {
         if( (*node)->tree == NULL )
         {
            DeleteNode(node);          /* (tree.c) */
            modified = 1;
            continue;
         }
         else if( (*node)->tree->token->type == TagColor &&
                  (*node)->tree->next == NULL )
         {
            PromoteSubtree(node);      /* (tree.c) */
            modified = 1;
            continue;
         }
      }
      else if( (*node)->token->type == TagSize )
      {
         if( (*node)->tree == NULL )
         {
            DeleteNode(node);
            modified = 1;
            continue;
         }
         if( (*node)->tree->token->type == TagSize &&
             (*node)->tree->next == NULL )
         {
            PromoteSubtree(node);
            modified = 1;
            continue;
         }
      }

      if( (*node)->tree )
         modified |= o_trivial_overlap(&((*node)->tree));
      node = &((*node)->next);
   }
   return modified;

} /* o_trivial_overlap() */
