/* o_pl.c - PL optimization - Don Yang / Dave Newquist / John Rapp

   07/28/01
                                                                           */

#include<assert.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include"smlng.h"
#include"token.h"
#include"tree.h"


/* Local functions */
static int PromotePL(Node **node);

/************************************************************** o_pl_plain */
int o_pl_plain(Node **node)
{
   Attr *attr;
   int modified;

   modified = 0;
   while( *node )
   {
      if( (*node)->token->type == TagPL )
      {
         attr = &((*node)->attr);
         if( !attr->tt && !attr->b && !attr->i && !attr->s && !attr->em &&
             attr->u == 0 )
         {
            PromoteSubtree(node);
            modified = 1;
            continue;
         }
      }
      if( (*node)->tree )
      {
         if( PromotePL(node) )
         {
            modified = 1;
            continue;
         }
         modified |= o_pl_plain(&((*node)->tree));
      }
      node = &((*node)->next);
   }

   return modified;

} /* o_pl_plain() */

/************************************************************** o_pl_short */
int o_pl_short(Node **node)
{
   /*XXX*/

   return 0;

} /* o_pl_short() */


/*************************************************************** PromotePL */
static int PromotePL(Node **node)
{
   Node *cursor, *parent, *n;

   /* Find PL attribute in enclosing tag */
   parent = NULL;
   for(cursor = *node; cursor; cursor = cursor->tree)
   {
      if( cursor->token->tagtype == 0 ||
          cursor->token->type == TagSize || cursor->token->type == TagColor )
         return 0;

      if( cursor->token->type == TagPL )  break;
      if( cursor->next != NULL )          return 0;
      parent = cursor;
   }
   if( parent == NULL )
      return 0;

   /* Move PL tag to current level */
   n = cursor->next;
   cursor->next = *node;
   *node = cursor;

   /* Shift subtree */
   assert(parent->tree == cursor);
   parent->tree = n;
   return 1;

} /* PromotePL() */
